# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

rcpp_sum <- function(v) {
    .Call(`_lpcde_rcpp_sum`, v)
}

#' @title All Sums in C++ (Internal Function)
#' @description Function that prints all combinations of natural numbers that
#' add up to target value.
#' @param target target value for sum.
#' @return list of combinations that add up to target value.
#' @keywords internal
print_all_sumC <- function(target) {
    .Call(`_lpcde_print_all_sumC`, target)
}

#' @title Kernel function C++ (Internal Function)
#' @description Multivariate product kernel evaluation function. Compatible with uniform,
#' triangular and epanechnikov kernels.
#' @param x evaluation point.
#' @param kernel_type kernel function type.
#' @return kernel evaluated at \code{x}.
#' @keywords internal
kernel_evalC <- function(x, kernel_type) {
    .Call(`_lpcde_kernel_evalC`, x, kernel_type)
}

#' @title Polynomial basis expansion in C++
#' @description polynomial basis function for univariate and multivariate input.
#' @param x a number or vector.
#' @param p order of polynomial expansion.
#' @return vector of polynomial expansion of \code{x} up to order \code{p}.
#' @keywords internal
poly_baseC <- function(x, p) {
    .Call(`_lpcde_poly_baseC`, x, p)
}

#' @title unit basis vector in C++
#' @description unit vector basis function.
#' @param x a number or vector.
#' @param p a number.
#' @param mu a number.
#' @return unit vector of appropriate length with ones corresponding to entries of order \code{mu}.
#' @keywords internal
basis_vecC <- function(x, p, mu) {
    .Call(`_lpcde_basis_vecC`, x, p, mu)
}

#' @title S matrix in C++ (Internal Function)
#' @description Sx matrix pull from R.
#' @param x_data raw data vector or matrix.
#' @param x evaluation point.
#' @param q a number.
#' @param bw banwidth.
#' @param kernel_type type of kernel used
#' @return Sx matrix.
#' @keywords internal
SxmatC <- function(x_data, q, kernel_type) {
    .Call(`_lpcde_SxmatC`, x_data, q, kernel_type)
}

rowSums <- function(X) {
    .Call(`_lpcde_rowSums`, X)
}

#' @title lp integral evaluation in C++ (Internal Function)
#' @description local polynomial integral evaluation calculation of elements
#' of S_y and middle integral (evaluating integral at end points)
#' @param l degree of polynomial being integrated.
#' @param a lower limit of integration.
#' @param b upper limit of integration.
#' @param kernel_type type of kernel function. Choose from "uniform", "triangular", "epanechnikov".
#' @return value of integral.
#' @keywords internal
int_valC <- function(l, a, b, kernel_type) {
    .Call(`_lpcde_int_valC`, l, a, b, kernel_type)
}

